<?php
namespace Pinpoint\CarouselManager\Controller\Adminhtml\Carousel;

use Magento\Backend\App\Action;
use Magento\Framework\Controller\Result\JsonFactory;
use Pinpoint\CarouselManager\Model\SlideRepository;

/**
 * Class Itemdelete
 * @package Pinpoint\CarouselManager\Controller\Adminhtml\Carousel
 */
class ItemDelete extends Action
{

    /**
     * Authorization level of a basic admin session
     *
     * @see _isAllowed()
     */
    const ADMIN_RESOURCE = 'Pinpoint_CarouselManager::carousel';

    /**
     * @var JsonFactory
     */
    protected $resultJsonFactory;

    /**
     * @var \Pinpoint\CarouselManager\Model\CarouselFactory
     */
    protected $slideRespository;

    /**
     * Itemdelete constructor.
     * @param Action\Context $context
     * @param JsonFactory $resultJsonFactory
     * @param SlideRepository $slideRespository
     */
    public function __construct(
        Action\Context $context,
        JsonFactory $resultJsonFactory,
        SlideRepository $slideRespository
    ) {
        parent::__construct($context);
        $this->resultJsonFactory = $resultJsonFactory;
        $this->slideRespository = $slideRespository;
    }

    /**
     * @return mixed
     */
    public function execute()
    {
        $resultPage = $this->resultJsonFactory->create();
        // check if we know what should be deleted
        $itemId = $this->getRequest()->getParam('itemId');

        if ($itemId) {
            try {

                $this->slideRespository->deleteById($itemId);
                return $resultPage->setData(['success' => true]);

            } catch (\Exception $e) {
                return $resultPage->setData(['success' => false]);
            }
        }

        return $resultPage->setData(['success' => false]);

    }

}
