<?php
/**
 * This script `included` via class method, inherits this variable from that context
 * @var $setup \Magento\Framework\Setup\SchemaSetupInterface
 */
$setup;

/**
 * This script `included` via class method, inherits this variable from that context
 * @var $setup \Magento\Framework\Setup\ModuleContextInterface
 */
$context;

//create a table
$table = $setup->getConnection()
    ->newTable($setup->getTable('pinpoint_carousel'))
    ->addColumn(
        'id',
        \Magento\Framework\DB\Ddl\Table::TYPE_INTEGER,
        null,
        ['identity' => true, 'unsigned' => true, 'nullable' => false, 'primary' => true],
        'Carousel ID'
    )
    ->addColumn(
        'name',
        \Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
        200,
        ['nullable' => true, 'default' => null],
        'Carousel Name'
    )
    ->addColumn(
        'store_ids',
        \Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
        null,
        ['nullable' => true, 'default' => null],
        'Store Ids'
    );

$setup->getConnection()->createTable($table);

//create a table
$table = $setup->getConnection()
    ->newTable($setup->getTable('pinpoint_carousel_slide'))
    ->addColumn(
        'id',
        \Magento\Framework\DB\Ddl\Table::TYPE_INTEGER,
        null,
        ['identity' => true, 'unsigned' => true, 'nullable' => false, 'primary' => true],
        'Slide ID'
    )
    ->addColumn(
        'carousel_id',
        \Magento\Framework\DB\Ddl\Table::TYPE_INTEGER,
        null,
        ['unsigned' => true, 'nullable' => false],
        'Carousel ID'
    )
    ->addColumn(
        'title',
        \Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
        200,
        ['nullable' => true, 'default' => null],
        'Slide Title'
    )
    ->addColumn(
        'image',
        \Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
        200,
        ['nullable' => true, 'default' => null],
        'Slide Image'
    )
    ->addColumn(
        'description',
        \Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
        null,
        ['nullable' => true, 'default' => null],
        'Slide Description Text'
    )
    ->addColumn(
        'cta',
        \Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
        null,
        ['nullable' => true, 'default' => null],
        'Slide CTA text'
    )
    ->addColumn(
        'link',
        \Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
        null,
        ['nullable' => true, 'default' => null],
        'Slide Link'
    )
    ->addForeignKey(
        $setup->getFkName('pinpoint_carousel', 'id', 'pinpoint_carousel_slide', 'carousel_id'),
        'carousel_id',
        $setup->getTable('pinpoint_carousel'),
        'id',
        \Magento\Framework\DB\Ddl\Table::ACTION_CASCADE
    );

$setup->getConnection()->createTable($table);